Bug 1401302 - Review Request: libarcus - Communication library between internal components for Ultimaker software
Summary: Review Request: libarcus - Communication library between internal components ...
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Pavlina Moravcova Varekova
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks: 1393176 1435914
TreeView+ depends on / blocked
 
Reported: 2016-12-04 13:25 UTC by Miro Hrončok
Modified: 2017-05-09 21:23 UTC (History)
4 users (show)

Fixed In Version: libarcus-2.4.0-1.fc26
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2017-05-09 21:23:46 UTC
Type: ---
pmoravco: fedora-review+


Attachments (Terms of Use)

Description Miro Hrončok 2016-12-04 13:25:05 UTC
Spec URL: https://churchyard.fedorapeople.org/SRPMS/libarcus.spec
SRPM URL: https://churchyard.fedorapeople.org/SRPMS/libarcus-2.1.3-1.fc25.src.rpm

Description:
Arcus library contains C++ code and Python 3 bindings for creating a socket in
a thread and using this socket to send and receive messages based on the
Protocol Buffers library. It is designed to facilitate the communication
between Cura and its backend and similar code.

Fedora Account System Username: churchyard

Comment 1 Miro Hrončok 2016-12-04 16:46:16 UTC
Accidentally packaged 2.1.3 instead of 2.3.1, will fix this.

Comment 3 Michael Schwendt 2016-12-13 00:37:23 UTC
> %description
> Arcus library contains C++ code and Python 3 bindings

Then you will need "BuildRequires: gcc-c++" as per this year's changes to the buildroots to make them cleaner.


> %package        devel
> Summary:        Development files for libarcus
> Requires:       %{name} = %{version}-%{release}

It's supposed to be an arch-specific dependency for a long time:
https://fedoraproject.org/wiki/Packaging:Guidelines#Requiring_Base_Package


> %files devel
> %doc examples/example.cpp examples/example.proto
> %{_libdir}/libArcus.so
> %{_libdir}/cmake/Arcus

https://fedoraproject.org/wiki/Packaging:Guidelines#The_directory_is_owned_by_a_package_which_is_not_required_for_your_package_to_function

Comment 4 Miro Hrončok 2016-12-19 13:45:36 UTC
Spec URL: https://churchyard.fedorapeople.org/SRPMS/libarcus.spec
SRPM URL: https://churchyard.fedorapeople.org/SRPMS/libarcus-2.1.3-1.fc25.src.rpm

Thanks for feedback. Fixed:

 * added BR gcc-c++
 * make arch specific dependency on main package
 * own the entire cmake dir

Comment 6 Pavlina Moravcova Varekova 2017-03-14 09:50:26 UTC
Packaged 2.1.3 instead of 2.3.1.

Comment 7 Miro Hrončok 2017-03-14 10:03:19 UTC
Yes and than updated it 2 comments later.

Comment 8 Miro Hrončok 2017-03-14 10:04:33 UTC
s/than/then/

Comment 9 Miro Hrončok 2017-03-14 10:12:46 UTC
Oh, sorry. Now I get it. Just bad link.

Spec URL: https://churchyard.fedorapeople.org/SRPMS/libarcus.spec
SRPM URL: https://churchyard.fedorapeople.org/SRPMS/libarcus-2.3.1-1.fc25.src.rpm

Comment 11 Pavlina Moravcova Varekova 2017-03-28 04:57:24 UTC
Fedora-review in Rpmlint section contains:

libarcus.x86_64: W: hidden-file-or-dir /usr/lib/.build-id
libarcus.x86_64: W: hidden-file-or-dir /usr/lib/.build-id
..
libarcus-devel.x86_64: W: only-non-binary-in-usr-lib
..
python3-arcus.x86_64: W: hidden-file-or-dir /usr/lib/.build-id
python3-arcus.x86_64: W: hidden-file-or-dir /usr/lib/.build-id

It should be fixed.

Comment 12 Jaroslav Škarvada 2017-03-28 08:36:27 UTC
(In reply to Pavlina Moravcova Varekova from comment #11)
> Fedora-review in Rpmlint section contains:
> 
> libarcus.x86_64: W: hidden-file-or-dir /usr/lib/.build-id
> libarcus.x86_64: W: hidden-file-or-dir /usr/lib/.build-id
> ..
> libarcus-devel.x86_64: W: only-non-binary-in-usr-lib
> ..
> python3-arcus.x86_64: W: hidden-file-or-dir /usr/lib/.build-id
> python3-arcus.x86_64: W: hidden-file-or-dir /usr/lib/.build-id
> 
> It should be fixed.

I checked it and it doesn't seem like packaging error, but like some bug in rpmbuild, because the SPEC file of libarcus seems correct. I can reproduce this problem with other packages in rawhide as well, so it's probably not blocker for review.

Comment 13 Jaroslav Škarvada 2017-03-28 08:41:51 UTC
(In reply to Jaroslav Škarvada from comment #12)
> (In reply to Pavlina Moravcova Varekova from comment #11)
> > Fedora-review in Rpmlint section contains:
> > 
> > libarcus.x86_64: W: hidden-file-or-dir /usr/lib/.build-id
> > libarcus.x86_64: W: hidden-file-or-dir /usr/lib/.build-id
> > ..
> > libarcus-devel.x86_64: W: only-non-binary-in-usr-lib
> > ..
> > python3-arcus.x86_64: W: hidden-file-or-dir /usr/lib/.build-id
> > python3-arcus.x86_64: W: hidden-file-or-dir /usr/lib/.build-id
> > 
> > It should be fixed.
> 
> I checked it and it doesn't seem like packaging error, but like some bug in
> rpmbuild, because the SPEC file of libarcus seems correct. I can reproduce
> this problem with other packages in rawhide as well, so it's probably not
> blocker for review.

Not rpmbuild bug, but rplmint bug, the build-id should be now always there, it's feature allowing parallel installation of multiple arch debuginfo:
https://fedoraproject.org/wiki/Changes/ParallelInstallableDebuginfo

The rpmlint bug 1431408.

Comment 14 Jaroslav Škarvada 2017-03-28 08:50:55 UTC
> libarcus-devel.x86_64: W: only-non-binary-in-usr-lib

This one is false positive, probably due to cmake files and DSO symlink (no binary content), thus probably also OK.

Comment 15 Miro Hrončok 2017-03-28 09:55:47 UTC
(In reply to Jaroslav Škarvada from comment #14)
> > libarcus-devel.x86_64: W: only-non-binary-in-usr-lib
> 
> This one is false positive, probably due to cmake files and DSO symlink (no
> binary content), thus probably also OK.

Exactly.

Comment 17 Jaroslav Škarvada 2017-03-28 10:56:28 UTC
Few comments from me, but none is blocker:
> BuildRequires:  python3-sip

This is not needed, because there is already:
> BuildRequires:  python3-sip-devel

It's guaranteed by guidelines that it will bring-in the python3-sip package automatically.

> %if "%{_libdir}" == "/usr/lib64"
> sed -i 's|DESTINATION lib|DESTINATION lib64|g' CMakeLists.txt
> sed -i 's|PYTHON_SITE_PACKAGES_DIR lib|PYTHON_SITE_PACKAGES_DIR lib64|g'  CMakeLists.txt
> %endif

Maybe simpler way:
sed -i 's|DESTINATION lib|DESTINATION %{_lib}|g' CMakeLists.txt
sed -i 's|PYTHON_SITE_PACKAGES_DIR lib|PYTHON_SITE_PACKAGES_DIR %{_lib}|g'

But maybe better is to patch the cmake files (and persuade upstream) to incorporate support for -DLIB_SUFFIX=64, in this way it will work out of the box.

Is the patch needed? Couldn't be the same behavior achieved by e.g.:
 cmake -DCMAKE_SKIP_RPATH:BOOL=ON

Comment 18 Pavlina Moravcova Varekova 2017-03-28 11:15:14 UTC
Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed


Issues:
=======


===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[x]: Development (unversioned) .so files in -devel subpackage, if present.
     Note: Unversioned so-files in private %_libdir subdirectory (see
     attachment). Verify they are not in ld path.
[x]: Header files in -devel subpackage, if present.
[x]: ldconfig called in %post and %postun if required.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "AGPL (v3 or later)", "Unknown or generated", "*No copyright*
     BSD (3 clause)". 8 files have unknown license. Detailed output of
     licensecheck in
     /home/pavlina/work/review/209/1401302-libarcus/licensecheck.txt
[x]: License file installed when any subpackage combination is installed.
[x]: Package does not own files or directories owned by other packages.
     Note: Dirs in package are owned also by: /usr/lib64/cmake(qt5-qtbase)
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[x]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[-]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[x]: Package contains systemd file(s) if in need.
[x]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[x]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 40960 bytes in 7 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Fully versioned dependency in subpackages if applicable.
     Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in
     python3-arcus , libarcus-debuginfo
[?]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: Patches link to upstream bugs/comments/lists or are otherwise
     justified.
[x]: Scriptlets must be sane, if used.
[x]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[-]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Uses parallel make %{?_smp_mflags} macro.
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on debuginfo package(s).
     Note: No rpmlint messages.
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Large data in /usr/share should live in a noarch subpackage if package
     is arched.
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: libarcus-2.4.0-1.fc27.x86_64.rpm
          libarcus-devel-2.4.0-1.fc27.x86_64.rpm
          python3-arcus-2.4.0-1.fc27.x86_64.rpm
          libarcus-debuginfo-2.4.0-1.fc27.x86_64.rpm
          libarcus-2.4.0-1.fc27.src.rpm
libarcus.x86_64: W: spelling-error %description -l en_US Arcus -> Arius, Argus, Arcs
libarcus.x86_64: W: spelling-error %description -l en_US backend -> backed, back end, back-end
libarcus.x86_64: W: hidden-file-or-dir /usr/lib/.build-id
libarcus.x86_64: W: hidden-file-or-dir /usr/lib/.build-id
libarcus-devel.x86_64: W: spelling-error %description -l en_US backend -> backed, back end, back-end
libarcus-devel.x86_64: W: only-non-binary-in-usr-lib
python3-arcus.x86_64: W: spelling-error Summary(en_US) libArcus -> millibars
python3-arcus.x86_64: W: spelling-error %description -l en_US backend -> backed, back end, back-end
python3-arcus.x86_64: W: hidden-file-or-dir /usr/lib/.build-id
python3-arcus.x86_64: W: hidden-file-or-dir /usr/lib/.build-id
libarcus.src: W: spelling-error %description -l en_US Arcus -> Arius, Argus, Arcs
libarcus.src: W: spelling-error %description -l en_US backend -> backed, back end, back-end
5 packages and 0 specfiles checked; 0 errors, 12 warnings.




Rpmlint (debuginfo)
-------------------
Checking: libarcus-debuginfo-2.4.0-1.fc27.x86_64.rpm
1 packages and 0 specfiles checked; 0 errors, 0 warnings.





Rpmlint (installed packages)
----------------------------
Cannot parse rpmlint output:


Requires
--------
libarcus-debuginfo (rpmlib, GLIBC filtered):

python3-arcus (rpmlib, GLIBC filtered):
    libArcus.so.3()(64bit)
    libc.so.6()(64bit)
    libgcc_s.so.1()(64bit)
    libgcc_s.so.1(GCC_3.0)(64bit)
    libm.so.6()(64bit)
    libprotobuf.so.12()(64bit)
    libpython3.6m.so.1.0()(64bit)
    libstdc++.so.6()(64bit)
    libstdc++.so.6(CXXABI_1.3)(64bit)
    python(abi)
    rtld(GNU_HASH)

libarcus-devel (rpmlib, GLIBC filtered):
    libArcus.so.3()(64bit)
    libarcus(x86-64)

libarcus (rpmlib, GLIBC filtered):
    /sbin/ldconfig
    libc.so.6()(64bit)
    libgcc_s.so.1()(64bit)
    libgcc_s.so.1(GCC_3.0)(64bit)
    libm.so.6()(64bit)
    libprotobuf.so.12()(64bit)
    libstdc++.so.6()(64bit)
    libstdc++.so.6(CXXABI_1.3)(64bit)
    rtld(GNU_HASH)



Provides
--------
libarcus-debuginfo:
    libarcus-debuginfo
    libarcus-debuginfo(x86-64)

python3-arcus:
    python3-arcus
    python3-arcus(x86-64)

libarcus-devel:
    cmake(Arcus)
    libarcus-devel
    libarcus-devel(x86-64)

libarcus:
    libArcus.so.3()(64bit)
    libarcus
    libarcus(x86-64)



Unversioned so-files
--------------------
python3-arcus: /usr/lib64/python3.6/site-packages/Arcus.so

Source checksums
----------------
https://github.com/Ultimaker/libArcus/archive/2.4.0.tar.gz#/libarcus-2.4.0.tar.gz :
  CHECKSUM(SHA256) this package     : 267e82d0c3b061a850b9e11dfdd2d4741d21bd1dd37f80b96313e4965d37f224
  CHECKSUM(SHA256) upstream package : 267e82d0c3b061a850b9e11dfdd2d4741d21bd1dd37f80b96313e4965d37f224


Generated by fedora-review 0.6.1 (f03e4e7) last change: 2016-05-02
Command line :/usr/bin/fedora-review -m fedora-rawhide-x86_64 -b 1401302
Buildroot used: fedora-rawhide-x86_64
Active plugins: Generic, Shell-api, C/C++
Disabled plugins: Java, Python, fonts, SugarActivity, Ocaml, Perl, Haskell, R, PHP
Disabled flags: EXARCH, DISTTAG, EPEL5, BATCH, EPEL6

Comment 19 Miro Hrončok 2017-03-28 11:28:10 UTC
(In reply to Jaroslav Škarvada from comment #17)
> Few comments from me, but none is blocker:
> > BuildRequires:  python3-sip
> 
> This is not needed, because there is already:
> > BuildRequires:  python3-sip-devel
> 
> It's guaranteed by guidelines that it will bring-in the python3-sip package
> automatically.
Right.

> 
> > %if "%{_libdir}" == "/usr/lib64"
> > sed -i 's|DESTINATION lib|DESTINATION lib64|g' CMakeLists.txt
> > sed -i 's|PYTHON_SITE_PACKAGES_DIR lib|PYTHON_SITE_PACKAGES_DIR lib64|g'  CMakeLists.txt
> > %endif
> 
> Maybe simpler way:
> sed -i 's|DESTINATION lib|DESTINATION %{_lib}|g' CMakeLists.txt
> sed -i 's|PYTHON_SITE_PACKAGES_DIR lib|PYTHON_SITE_PACKAGES_DIR %{_lib}|g'
Sure.

> But maybe better is to patch the cmake files (and persuade upstream) to
> incorporate support for -DLIB_SUFFIX=64, in this way it will work out of the
> box.
Will do later.

> Is the patch needed? Couldn't be the same behavior achieved by e.g.:
>  cmake -DCMAKE_SKIP_RPATH:BOOL=ON
Will try.

Thnak you both.

Comment 20 Miro Hrončok 2017-03-28 12:17:44 UTC
(In reply to Miro Hrončok from comment #19)
> (In reply to Jaroslav Škarvada from comment #17)
> > Few comments from me, but none is blocker:
> > > BuildRequires:  python3-sip
> > 
> > This is not needed, because there is already:
> > > BuildRequires:  python3-sip-devel
> > 
> > It's guaranteed by guidelines that it will bring-in the python3-sip package
> > automatically.

Done.

> > > %if "%{_libdir}" == "/usr/lib64"
> > > sed -i 's|DESTINATION lib|DESTINATION lib64|g' CMakeLists.txt
> > > sed -i 's|PYTHON_SITE_PACKAGES_DIR lib|PYTHON_SITE_PACKAGES_DIR lib64|g'  CMakeLists.txt
> > > %endif
> > 
> > Maybe simpler way:
> > sed -i 's|DESTINATION lib|DESTINATION %{_lib}|g' CMakeLists.txt
> > sed -i 's|PYTHON_SITE_PACKAGES_DIR lib|PYTHON_SITE_PACKAGES_DIR %{_lib}|g'

Done.

> > Is the patch needed? Couldn't be the same behavior achieved by e.g.:
> >  cmake -DCMAKE_SKIP_RPATH:BOOL=ON
> Will try.

Works.

Comment 21 Gwyn Ciesla 2017-03-28 19:02:09 UTC
Package request has been approved: https://admin.fedoraproject.org/pkgdb/package/rpms/libarcus

Comment 22 Miro Hrončok 2017-04-01 16:16:36 UTC
Built in rawhide and F26. Created a buildroot override https://bodhi.fedoraproject.org/overrides/libarcus-2.4.0-1.fc26 not doing the update separately, will create a multi-update later.

Comment 23 Fedora Update System 2017-05-04 17:05:13 UTC
libarcus-2.5.0-1.fc26 libsavitar-0-0.1.20170501git1ad7ddb.fc26 python-uranium-2.5.0-2.fc26 has been submitted as an update to Fedora 26. https://bodhi.fedoraproject.org/updates/FEDORA-2017-e78f6e9169

Comment 24 Fedora Update System 2017-05-05 22:37:57 UTC
libarcus-2.5.0-1.fc26, libsavitar-0-0.1.20170501git1ad7ddb.fc26, python-uranium-2.5.0-2.fc26 has been pushed to the Fedora 26 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2017-e78f6e9169

Comment 25 Fedora Update System 2017-05-09 21:23:46 UTC
libarcus-2.5.0-1.fc26, libsavitar-0-0.1.20170501git1ad7ddb.fc26, python-uranium-2.5.0-2.fc26 has been pushed to the Fedora 26 stable repository. If problems still persist, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.